// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services','starter.network','pascalprecht.translate','ngCookies','starter.filters','starter.directives','sly'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleBlackOpaque();
    }
    setTimeout(function() {
      navigator.splashscreen.hide();
    }, 100);
  });

  $ionicPlatform.registerBackButtonAction(function () {
    navigator.app.exitApp();
  }, 100);
})

.config(function($stateProvider, $urlRouterProvider, $translateProvider) {
  $stateProvider
  .state('fav', {
    url: "/fav",
    abstract: true,
    templateUrl: "templates/tabs.html"
  })
  .state('fav.work-day', {
    url: "/work-day",
    views: {
      'work-day-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('fav.sunday', {
    url: "/sunday",
    views: {
      'sunday-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('fav.saturday', {
    url: "/saturday",
    views: {
      'saturday-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('urban', {
    url: "/urban",
    abstract: true,
    templateUrl: "templates/tabs.html"
  })
  .state('urban.work-day', {
    url: "/work-day",
    views: {
      'work-day-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('urban.sunday', {
    url: "/sunday",
    views: {
      'sunday-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('urban.saturday', {
    url: "/saturday",
    views: {
      'saturday-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('suburban', {
    url: "/suburban",
    abstract: true,
    templateUrl: "templates/tabs.html"
  })
  .state('suburban.work-day', {
    url: "/work-day",
    views: {
      'work-day-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('suburban.sunday', {
    url: "/sunday",
    views: {
      'sunday-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('suburban.saturday', {
    url: "/saturday",
    views: {
      'saturday-tab': {
        templateUrl: "templates/lines.html",
        controller: "LinesCtrl"
      }
    }
  })
  .state('intro', {
    url: '/intro',
    templateUrl: 'templates/intro.html',
    controller: 'IntroCtrl'
  });

  // if none of the above states are matched, use this as the fallback
  if(window.localStorage['version']) {
    $urlRouterProvider.otherwise("/fav/"+currentDay());
  } else {
    $urlRouterProvider.otherwise("/intro");
  }

  for(var lang in translations){
    $translateProvider.translations(lang, translations[lang]);
  }
  $translateProvider.preferredLanguage('rs');
  $translateProvider.useLocalStorage();

  function currentDay() {
    switch(new Date().getDay()) {
      case 0:
        return 'sunday';
      case 6:
        return 'saturday';
      default:
        return 'work-day';
    }
  }
});
