angular.module('starter.controllers', [])

.controller('NavCtrl', function($scope, $state, $rootScope, $translate, $ionicSideMenuDelegate, Time) {
  $scope.activeDay = Time.currentDay();
  $scope.page = undefined;

  $scope.navigate = function(type) {
    $state.go(type + '.' + $scope.activeDay);
  };

  $scope.showMenu = function () {
    $ionicSideMenuDelegate.toggleLeft();
  };

  if($translate.use() === 'rs') {
    $scope.language = 'English';
  } else {
    $scope.language = 'Srpski';
  }
  $scope.language = function() {

    if($translate.use() === 'rs') {
      return 'English';
    } else {
      return 'Srpski';
    }
  };

  $scope.switchLanguage = function () {
    if($translate.use() == 'rs') {
      $translate.use('en');
    } else {
      $translate.use('rs');
    }
  };

  $rootScope.$on('$stateChangeSuccess', function(event, toState) {
    if(toState.name == 'intro') {
      $scope.page = 'intro';
    } else {
      $scope.page = 'main';
      var name = toState.name.split('.');
      $scope.type = name[0];
      $scope.activeDay = name[1];
    }
    $ionicSideMenuDelegate.canDragContent($scope.page != 'intro');
  });

})

.controller('LinesCtrl', function($scope, $state, $ionicModal, $translate, $filter, Lines, Time, Updates) {
  var name = $state.current.name.split('.');
  $scope.type = name[0];
  $scope.day = name[1];

  $scope.currentHour = Time.currentHour;
  $scope.exp = [];

  $scope.expand = function(id) {
    var index = $scope.exp.indexOf(id);
    if (index > -1) {
      $scope.exp.splice(index, 1);
    } else {
      $scope.exp.pushIfNotExist(id, function(e) {
          return e === id;
      });
    }
  };

  $scope.expanded = function(id) {
    return $scope.exp.indexOf(id) >= 0;
  };

  switch(name[1]){
    case 'work-day':
      $scope.d = 'r';
      break;
    case 'saturday':
      $scope.d = 's';
      break;
    case 'sunday':
      $scope.d = 'n';
      break;
  }

  $scope.routes = routes;
  $scope.favorites = Lines.favorites();
  if($scope.type == 'fav') {
    $scope.language = $translate.use();
    $scope.showTut = function() {
      return $scope.favorites.length <= 0;
    };
  }
  var filter;
  switch(name[0]){
    case 'fav':
      $scope.type = 'favorites';
      filter = $scope.favorites;
      break;
    case 'urban':
      filter = 'RVG';
      break;
    case 'suburban':
      filter = 'RVP';
      break;
  }

  $scope.lines = $filter('filerLines')(Lines.lines(), filter);
  if (name[0] == 'fav') {
    $scope.$watch('favorites', function() {
      $scope.lines = $filter('filerLines')(Lines.lines(), filter);
    }, true);
  }

  $scope.toggleFavourite = function(line) {
    Lines.toggleFavourite(line);
  };

  // updating schedule
  $scope.state = Updates.state;
  $ionicModal.fromTemplateUrl('templates/updates.html', {
    scope: $scope,
    animation: 'slide-in-up',
    backdropClickToClose: false,
    hardwareBackButtonClose: false,
  }).then(function(modal) {
    $scope.modal = modal;
      if(Updates.state() == 'hasUpdates'){
        $scope.openModal();
      }
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
  $scope.updateSchedule = function() {
      Updates.update().then(function(lines){
          $scope.lines =  $filter('filerLines')(lines, filter);
      });
  };
  $scope.cancelUpdate = function() {
    $scope.closeModal();
    var oldState = Updates.state();
    $scope.state = function() {
      return oldState;
    };
    Updates.cancel();
  };
  Updates.check().then(function(hasUpdates){
    if(hasUpdates && Updates.state() == 'hasUpdates') {
      $scope.openModal();
    }
  });
})

.controller('IntroCtrl', function($scope, $state, $ionicSlideBoxDelegate, $timeout, $translate, Time, Updates) {
  var toApp = function() {
      $state.go('fav.' + Time.currentDay());
  };

  $timeout(function(){
    $ionicSlideBoxDelegate.enableSlide(0);
  },0);

  Updates.check().then(function(){
    Updates.update();
  });
  $scope.state = Updates.state;
  $scope.retry = function(){
    Updates.update();
  };

  // Called to navigate to the main app
  $scope.startApp = function() {
      toApp();
  };

  $scope.next = function() {
    $ionicSlideBoxDelegate.next();
  };
  $scope.previous = function() {
    $ionicSlideBoxDelegate.previous();
  };
  $scope.hideNext = function(slideIndex) {
    return slideIndex > 1 || (slideIndex == 1 && $scope.state() != 'updated');
  };
  // Called each time the slide changes
  $scope.slideChanged = function(index) {
    $scope.slideIndex = index;
  };

  $scope.language = $translate.use();

  $scope.changeLanguage = function (key) {
    $translate.use(key);
    $scope.language = $translate.use();
  };
});
