angular.module('starter.filters', [])

.filter('filerLines', function() {
  return function(items, arg) {
    var filtered = [];
    if( typeof arg === 'string' ) {
      // by type
      angular.forEach(items, function(item) {
        if(item.type == arg) {
          filtered.push(item);
        }
      });
    } else {
      // by favorites
      angular.forEach(items, function(item) {
        if(item.fav) {
          filtered.push(item);
        }
      });
    }
    return filtered;
  };
})

.filter('routeName', function(){
  return function(id){
    if (id >= 21){
      return routes[id];
    } else {
      return routes[id].join(' <i></i> ');
    }
  };
})

.filter('sideName', ['$translate', function($translate) {
  var sideFilter = function (id, side) {
    if (id >= 21) {
      if(side === 'a'){
        return $translate.instant('to', {id:routes[id]});
      } else {
        return $translate.instant('from', {id:routes[id]});
      }
    } else if(id === '7' || id === '11'){
      return $translate.instant('direction', {side:side.toUpperCase()});
    } else {
      if(side === 'a') {
        return $translate.instant('from', {id:routes[id][0]});
      } else {
        var route = routes[id];
        return $translate.instant('from', {id:route[route.length - 1]});
      }
    }
  };
  sideFilter.$stateful = true;
  return sideFilter;
}])

.filter('currentHour', function(){
  return function(hour, currentHour){
    if(hour == currentHour) {
      return 'current';
    } else if(hour == currentHour - 1 || hour == currentHour + 1) {
      return 'around';
    } else {
      return '';
    }
  };
});
